#include <bits/stdc++.h>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    int a[n];
    for(int i = 0; i < n; i++)
        cin >> a[i];

    for(int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        int sol = a[l - 1];
        for(int j = l; j < r; j++) {
            sol = (sol & a[j]);
        }

        cout << sol << endl;
    }

    return 0;
}